/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs

#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* Copy the first part of user declarations.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:339  */

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 335 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "ir3_parser.h".  */
#ifndef YY_IR3_YY_SRC_FREEDRENO_IR3_IR3_PARSER_H_INCLUDED
# define YY_IR3_YY_SRC_FREEDRENO_IR3_IR3_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int ir3_yydebug;
#endif
/* "%code requires" blocks.  */
#line 24 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:355  */

#include "ir3/ir3_assembler.h"
#include "ir3/ir3_shader.h"

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f);

#line 373 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:355  */

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    T_INT = 258,
    T_HEX = 259,
    T_FLOAT = 260,
    T_IDENTIFIER = 261,
    T_REGISTER = 262,
    T_CONSTANT = 263,
    T_A_LOCALSIZE = 264,
    T_A_CONST = 265,
    T_A_BUF = 266,
    T_A_INVOCATIONID = 267,
    T_A_WGID = 268,
    T_A_NUMWG = 269,
    T_A_BRANCHSTACK = 270,
    T_A_IN = 271,
    T_A_OUT = 272,
    T_A_TEX = 273,
    T_A_PVTMEM = 274,
    T_A_EARLYPREAMBLE = 275,
    T_ABSNEG = 276,
    T_NEG = 277,
    T_ABS = 278,
    T_R = 279,
    T_HR = 280,
    T_HC = 281,
    T_EVEN = 282,
    T_POS_INFINITY = 283,
    T_NEG_INFINITY = 284,
    T_EI = 285,
    T_WRMASK = 286,
    T_FLUT_0_0 = 287,
    T_FLUT_0_5 = 288,
    T_FLUT_1_0 = 289,
    T_FLUT_2_0 = 290,
    T_FLUT_E = 291,
    T_FLUT_PI = 292,
    T_FLUT_INV_PI = 293,
    T_FLUT_INV_LOG2_E = 294,
    T_FLUT_LOG2_E = 295,
    T_FLUT_INV_LOG2_10 = 296,
    T_FLUT_LOG2_10 = 297,
    T_FLUT_4_0 = 298,
    T_SY = 299,
    T_SS = 300,
    T_JP = 301,
    T_SAT = 302,
    T_RPT = 303,
    T_UL = 304,
    T_NOP = 305,
    T_OP_NOP = 306,
    T_OP_BR = 307,
    T_OP_BRAO = 308,
    T_OP_BRAA = 309,
    T_OP_BRAC = 310,
    T_OP_BANY = 311,
    T_OP_BALL = 312,
    T_OP_BRAX = 313,
    T_OP_JUMP = 314,
    T_OP_CALL = 315,
    T_OP_RET = 316,
    T_OP_KILL = 317,
    T_OP_END = 318,
    T_OP_EMIT = 319,
    T_OP_CUT = 320,
    T_OP_CHMASK = 321,
    T_OP_CHSH = 322,
    T_OP_FLOW_REV = 323,
    T_OP_BKT = 324,
    T_OP_STKS = 325,
    T_OP_STKR = 326,
    T_OP_XSET = 327,
    T_OP_XCLR = 328,
    T_OP_GETLAST = 329,
    T_OP_GETONE = 330,
    T_OP_DBG = 331,
    T_OP_SHPS = 332,
    T_OP_SHPE = 333,
    T_OP_PREDT = 334,
    T_OP_PREDF = 335,
    T_OP_PREDE = 336,
    T_OP_MOVMSK = 337,
    T_OP_MOVA1 = 338,
    T_OP_MOVA = 339,
    T_OP_MOV = 340,
    T_OP_COV = 341,
    T_OP_SWZ = 342,
    T_OP_GAT = 343,
    T_OP_SCT = 344,
    T_OP_ADD_F = 345,
    T_OP_MIN_F = 346,
    T_OP_MAX_F = 347,
    T_OP_MUL_F = 348,
    T_OP_SIGN_F = 349,
    T_OP_CMPS_F = 350,
    T_OP_ABSNEG_F = 351,
    T_OP_CMPV_F = 352,
    T_OP_FLOOR_F = 353,
    T_OP_CEIL_F = 354,
    T_OP_RNDNE_F = 355,
    T_OP_RNDAZ_F = 356,
    T_OP_TRUNC_F = 357,
    T_OP_ADD_U = 358,
    T_OP_ADD_S = 359,
    T_OP_SUB_U = 360,
    T_OP_SUB_S = 361,
    T_OP_CMPS_U = 362,
    T_OP_CMPS_S = 363,
    T_OP_MIN_U = 364,
    T_OP_MIN_S = 365,
    T_OP_MAX_U = 366,
    T_OP_MAX_S = 367,
    T_OP_ABSNEG_S = 368,
    T_OP_AND_B = 369,
    T_OP_OR_B = 370,
    T_OP_NOT_B = 371,
    T_OP_XOR_B = 372,
    T_OP_CMPV_U = 373,
    T_OP_CMPV_S = 374,
    T_OP_MUL_U24 = 375,
    T_OP_MUL_S24 = 376,
    T_OP_MULL_U = 377,
    T_OP_BFREV_B = 378,
    T_OP_CLZ_S = 379,
    T_OP_CLZ_B = 380,
    T_OP_SHL_B = 381,
    T_OP_SHR_B = 382,
    T_OP_ASHR_B = 383,
    T_OP_BARY_F = 384,
    T_OP_FLAT_B = 385,
    T_OP_MGEN_B = 386,
    T_OP_GETBIT_B = 387,
    T_OP_SETRM = 388,
    T_OP_CBITS_B = 389,
    T_OP_SHB = 390,
    T_OP_MSAD = 391,
    T_OP_MAD_U16 = 392,
    T_OP_MADSH_U16 = 393,
    T_OP_MAD_S16 = 394,
    T_OP_MADSH_M16 = 395,
    T_OP_MAD_U24 = 396,
    T_OP_MAD_S24 = 397,
    T_OP_MAD_F16 = 398,
    T_OP_MAD_F32 = 399,
    T_OP_SEL_B16 = 400,
    T_OP_SEL_B32 = 401,
    T_OP_SEL_S16 = 402,
    T_OP_SEL_S32 = 403,
    T_OP_SEL_F16 = 404,
    T_OP_SEL_F32 = 405,
    T_OP_SAD_S16 = 406,
    T_OP_SAD_S32 = 407,
    T_OP_SHRM = 408,
    T_OP_SHLM = 409,
    T_OP_SHRG = 410,
    T_OP_SHLG = 411,
    T_OP_ANDG = 412,
    T_OP_DP2ACC = 413,
    T_OP_DP4ACC = 414,
    T_OP_WMM = 415,
    T_OP_WMM_ACCU = 416,
    T_OP_RCP = 417,
    T_OP_RSQ = 418,
    T_OP_LOG2 = 419,
    T_OP_EXP2 = 420,
    T_OP_SIN = 421,
    T_OP_COS = 422,
    T_OP_SQRT = 423,
    T_OP_HRSQ = 424,
    T_OP_HLOG2 = 425,
    T_OP_HEXP2 = 426,
    T_OP_ISAM = 427,
    T_OP_ISAML = 428,
    T_OP_ISAMM = 429,
    T_OP_SAM = 430,
    T_OP_SAMB = 431,
    T_OP_SAML = 432,
    T_OP_SAMGQ = 433,
    T_OP_GETLOD = 434,
    T_OP_CONV = 435,
    T_OP_CONVM = 436,
    T_OP_GETSIZE = 437,
    T_OP_GETBUF = 438,
    T_OP_GETPOS = 439,
    T_OP_GETINFO = 440,
    T_OP_DSX = 441,
    T_OP_DSY = 442,
    T_OP_GATHER4R = 443,
    T_OP_GATHER4G = 444,
    T_OP_GATHER4B = 445,
    T_OP_GATHER4A = 446,
    T_OP_SAMGP0 = 447,
    T_OP_SAMGP1 = 448,
    T_OP_SAMGP2 = 449,
    T_OP_SAMGP3 = 450,
    T_OP_DSXPP_1 = 451,
    T_OP_DSYPP_1 = 452,
    T_OP_RGETPOS = 453,
    T_OP_RGETINFO = 454,
    T_OP_BRCST_A = 455,
    T_OP_QSHUFFLE_BRCST = 456,
    T_OP_QSHUFFLE_H = 457,
    T_OP_QSHUFFLE_V = 458,
    T_OP_QSHUFFLE_DIAG = 459,
    T_OP_LDG = 460,
    T_OP_LDG_A = 461,
    T_OP_LDL = 462,
    T_OP_LDP = 463,
    T_OP_STG = 464,
    T_OP_STG_A = 465,
    T_OP_STL = 466,
    T_OP_STP = 467,
    T_OP_LDIB = 468,
    T_OP_G2L = 469,
    T_OP_L2G = 470,
    T_OP_PREFETCH = 471,
    T_OP_LDLW = 472,
    T_OP_STLW = 473,
    T_OP_RESFMT = 474,
    T_OP_RESINFO = 475,
    T_OP_ATOMIC_ADD = 476,
    T_OP_ATOMIC_SUB = 477,
    T_OP_ATOMIC_XCHG = 478,
    T_OP_ATOMIC_INC = 479,
    T_OP_ATOMIC_DEC = 480,
    T_OP_ATOMIC_CMPXCHG = 481,
    T_OP_ATOMIC_MIN = 482,
    T_OP_ATOMIC_MAX = 483,
    T_OP_ATOMIC_AND = 484,
    T_OP_ATOMIC_OR = 485,
    T_OP_ATOMIC_XOR = 486,
    T_OP_RESINFO_B = 487,
    T_OP_LDIB_B = 488,
    T_OP_STIB_B = 489,
    T_OP_ATOMIC_B_ADD = 490,
    T_OP_ATOMIC_B_SUB = 491,
    T_OP_ATOMIC_B_XCHG = 492,
    T_OP_ATOMIC_B_INC = 493,
    T_OP_ATOMIC_B_DEC = 494,
    T_OP_ATOMIC_B_CMPXCHG = 495,
    T_OP_ATOMIC_B_MIN = 496,
    T_OP_ATOMIC_B_MAX = 497,
    T_OP_ATOMIC_B_AND = 498,
    T_OP_ATOMIC_B_OR = 499,
    T_OP_ATOMIC_B_XOR = 500,
    T_OP_ATOMIC_S_ADD = 501,
    T_OP_ATOMIC_S_SUB = 502,
    T_OP_ATOMIC_S_XCHG = 503,
    T_OP_ATOMIC_S_INC = 504,
    T_OP_ATOMIC_S_DEC = 505,
    T_OP_ATOMIC_S_CMPXCHG = 506,
    T_OP_ATOMIC_S_MIN = 507,
    T_OP_ATOMIC_S_MAX = 508,
    T_OP_ATOMIC_S_AND = 509,
    T_OP_ATOMIC_S_OR = 510,
    T_OP_ATOMIC_S_XOR = 511,
    T_OP_ATOMIC_G_ADD = 512,
    T_OP_ATOMIC_G_SUB = 513,
    T_OP_ATOMIC_G_XCHG = 514,
    T_OP_ATOMIC_G_INC = 515,
    T_OP_ATOMIC_G_DEC = 516,
    T_OP_ATOMIC_G_CMPXCHG = 517,
    T_OP_ATOMIC_G_MIN = 518,
    T_OP_ATOMIC_G_MAX = 519,
    T_OP_ATOMIC_G_AND = 520,
    T_OP_ATOMIC_G_OR = 521,
    T_OP_ATOMIC_G_XOR = 522,
    T_OP_LDGB = 523,
    T_OP_STGB = 524,
    T_OP_STIB = 525,
    T_OP_LDC = 526,
    T_OP_LDLV = 527,
    T_OP_GETSPID = 528,
    T_OP_GETWID = 529,
    T_OP_GETFIBERID = 530,
    T_OP_STC = 531,
    T_OP_BAR = 532,
    T_OP_FENCE = 533,
    T_TYPE_F16 = 534,
    T_TYPE_F32 = 535,
    T_TYPE_U16 = 536,
    T_TYPE_U32 = 537,
    T_TYPE_S16 = 538,
    T_TYPE_S32 = 539,
    T_TYPE_U8 = 540,
    T_TYPE_S8 = 541,
    T_UNTYPED = 542,
    T_TYPED = 543,
    T_MIXED = 544,
    T_UNSIGNED = 545,
    T_LOW = 546,
    T_HIGH = 547,
    T_1D = 548,
    T_2D = 549,
    T_3D = 550,
    T_4D = 551,
    T_LT = 552,
    T_LE = 553,
    T_GT = 554,
    T_GE = 555,
    T_EQ = 556,
    T_NE = 557,
    T_S2EN = 558,
    T_SAMP = 559,
    T_TEX = 560,
    T_BASE = 561,
    T_OFFSET = 562,
    T_UNIFORM = 563,
    T_NONUNIFORM = 564,
    T_IMM = 565,
    T_NAN = 566,
    T_INF = 567,
    T_A0 = 568,
    T_A1 = 569,
    T_P0 = 570,
    T_W = 571,
    T_CAT1_TYPE_TYPE = 572
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 293 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:355  */

	int tok;
	int num;
	uint32_t unum;
	double flt;
	const char *str;
	struct ir3_register *reg;
	struct {
		int start;
		int num;
	} range;
	type_t type;

#line 717 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE ir3_yylval;

int ir3_yyparse (void);

#endif /* !YY_IR3_YY_SRC_FREEDRENO_IR3_IR3_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 307 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:358  */

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 744 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1396

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  343
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  172
/* YYNRULES -- Number of rules.  */
#define YYNRULES  543
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1137

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   572

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   324,     2,   325,     2,     2,     2,     2,
     320,   321,     2,   331,   319,   318,   326,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   323,     2,
     332,   322,   341,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   334,     2,   335,     2,     2,     2,   327,     2,   338,
       2,     2,     2,   333,   342,     2,     2,   337,   336,     2,
       2,   328,   329,     2,   340,   330,     2,     2,     2,   339,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   689,   689,   689,   691,   692,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   707,   708,
     709,   710,   712,   718,   723,   731,   733,   733,   739,   745,
     752,   759,   768,   770,   772,   775,   777,   779,   786,   787,
     788,   789,   790,   791,   792,   794,   795,   797,   798,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   810,   812,
     813,   815,   816,   818,   819,   821,   822,   822,   823,   823,
     824,   824,   825,   825,   826,   826,   827,   827,   828,   828,
     829,   829,   830,   830,   831,   832,   832,   833,   834,   835,
     836,   837,   838,   839,   839,   840,   841,   842,   843,   844,
     844,   845,   846,   846,   847,   848,   848,   849,   849,   850,
     851,   851,   853,   856,   860,   861,   863,   863,   879,   879,
     886,   886,   893,   893,   895,   895,   897,   897,   900,   901,
     902,   903,   904,   905,   906,   907,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     924,   925,   926,   927,   928,   929,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   959,   960,   961,   962,   963,   964,   966,
     967,   968,   970,   971,   973,   974,   976,   977,   978,   979,
     980,   981,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   993,   994,   995,   996,   997,   999,  1000,  1002,
    1003,  1005,  1006,  1007,  1008,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1021,  1023,  1024,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1071,  1072,  1073,  1074,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1093,  1094,  1096,  1097,  1098,  1099,  1101,  1102,  1103,
    1104,  1105,  1106,  1108,  1111,  1116,  1122,  1122,  1123,  1123,
    1124,  1124,  1125,  1125,  1126,  1126,  1127,  1127,  1127,  1131,
    1131,  1132,  1132,  1133,  1133,  1134,  1134,  1135,  1135,  1137,
    1137,  1138,  1138,  1140,  1140,  1142,  1143,  1144,  1145,  1146,
    1147,  1148,  1149,  1150,  1151,  1152,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1162,  1163,  1164,  1166,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1178,  1180,
    1182,  1184,  1185,  1186,  1188,  1190,  1191,  1193,  1194,  1195,
    1195,  1198,  1199,  1200,  1202,  1204,  1205,  1207,  1208,  1209,
    1211,  1212,  1214,  1216,  1217,  1218,  1219,  1220,  1221,  1222,
    1223,  1224,  1225,  1226,  1227,  1229,  1231,  1232,  1233,  1235,
    1239,  1240,  1242,  1248,  1249,  1250,  1252,  1252,  1254,  1255,
    1256,  1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,
    1267,  1268,  1269,  1271,  1272,  1273,  1274,  1276,  1277,  1279,
    1279,  1280,  1280,  1282,  1284,  1285,  1286,  1287,  1289,  1290,
    1291,  1292,  1294,  1296,  1297,  1298,  1299,  1300,  1302,  1303,
    1306,  1307,  1309,  1310,  1311,  1312,  1314,  1315,  1317,  1318,
    1320,  1321,  1323,  1324,  1326,  1327,  1329,  1330,  1331,  1333,
    1334,  1335,  1337,  1338,  1339,  1341,  1342,  1343,  1345,  1346,
    1348,  1349,  1351,  1352,  1354,  1355,  1361,  1362,  1363,  1364,
    1365,  1366,  1367,  1369,  1370,  1371,  1372,  1373,  1376,  1377,
    1378,  1379,  1380,  1381,  1382,  1383,  1384,  1385,  1386,  1387,
    1389,  1390,  1391,  1392,  1394,  1395,  1397,  1398,  1399,  1400,
    1401,  1402,  1403,  1404
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_INT", "T_HEX", "T_FLOAT",
  "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE", "T_A_CONST",
  "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_HR", "T_HC",
  "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI", "T_WRMASK",
  "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0", "T_FLUT_E",
  "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E", "T_FLUT_LOG2_E",
  "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0", "T_SY", "T_SS",
  "T_JP", "T_SAT", "T_RPT", "T_UL", "T_NOP", "T_OP_NOP", "T_OP_BR",
  "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC", "T_OP_BANY", "T_OP_BALL",
  "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL", "T_OP_RET", "T_OP_KILL",
  "T_OP_END", "T_OP_EMIT", "T_OP_CUT", "T_OP_CHMASK", "T_OP_CHSH",
  "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS", "T_OP_STKR", "T_OP_XSET",
  "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE", "T_OP_DBG", "T_OP_SHPS",
  "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF", "T_OP_PREDE", "T_OP_MOVMSK",
  "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV", "T_OP_COV", "T_OP_SWZ",
  "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F", "T_OP_MIN_F", "T_OP_MAX_F",
  "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F", "T_OP_ABSNEG_F",
  "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F", "T_OP_RNDNE_F",
  "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U", "T_OP_ADD_S", "T_OP_SUB_U",
  "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S", "T_OP_MIN_U", "T_OP_MIN_S",
  "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S", "T_OP_AND_B", "T_OP_OR_B",
  "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U", "T_OP_CMPV_S", "T_OP_MUL_U24",
  "T_OP_MUL_S24", "T_OP_MULL_U", "T_OP_BFREV_B", "T_OP_CLZ_S",
  "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B", "T_OP_ASHR_B", "T_OP_BARY_F",
  "T_OP_FLAT_B", "T_OP_MGEN_B", "T_OP_GETBIT_B", "T_OP_SETRM",
  "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD", "T_OP_MAD_U16",
  "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16", "T_OP_MAD_U24",
  "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32", "T_OP_SEL_B16",
  "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32", "T_OP_SEL_F16",
  "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32", "T_OP_SHRM", "T_OP_SHLM",
  "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG", "T_OP_DP2ACC", "T_OP_DP4ACC",
  "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP", "T_OP_RSQ", "T_OP_LOG2",
  "T_OP_EXP2", "T_OP_SIN", "T_OP_COS", "T_OP_SQRT", "T_OP_HRSQ",
  "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM", "T_OP_ISAML", "T_OP_ISAMM",
  "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML", "T_OP_SAMGQ", "T_OP_GETLOD",
  "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE", "T_OP_GETBUF", "T_OP_GETPOS",
  "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY", "T_OP_GATHER4R", "T_OP_GATHER4G",
  "T_OP_GATHER4B", "T_OP_GATHER4A", "T_OP_SAMGP0", "T_OP_SAMGP1",
  "T_OP_SAMGP2", "T_OP_SAMGP3", "T_OP_DSXPP_1", "T_OP_DSYPP_1",
  "T_OP_RGETPOS", "T_OP_RGETINFO", "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST",
  "T_OP_QSHUFFLE_H", "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG", "T_OP_STG_A",
  "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L", "T_OP_L2G",
  "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT", "T_OP_RESINFO",
  "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_BAR", "T_OP_FENCE", "T_TYPE_F16", "T_TYPE_F32",
  "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32", "T_TYPE_U8",
  "T_TYPE_S8", "T_UNTYPED", "T_TYPED", "T_MIXED", "T_UNSIGNED", "T_LOW",
  "T_HIGH", "T_1D", "T_2D", "T_3D", "T_4D", "T_LT", "T_LE", "T_GT", "T_GE",
  "T_EQ", "T_NE", "T_S2EN", "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET",
  "T_UNIFORM", "T_NONUNIFORM", "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1",
  "T_P0", "T_W", "T_CAT1_TYPE_TYPE", "'-'", "','", "'('", "')'", "'='",
  "':'", "'!'", "'#'", "'.'", "'a'", "'o'", "'p'", "'s'", "'+'", "'<'",
  "'g'", "'['", "']'", "'l'", "'k'", "'c'", "'w'", "'r'", "'>'", "'h'",
  "$accept", "shader", "$@1", "headers", "header", "const_val",
  "localsize_header", "const_header", "buf_header_addr_reg", "buf_header",
  "$@2", "invocationid_header", "wgid_header", "numwg_header",
  "branchstack_header", "pvtmem_header", "earlypreamble_header",
  "in_header", "out_header", "tex_header", "iflag", "iflags", "instrs",
  "instr", "label", "cat0_src1", "cat0_src2", "cat0_immed", "cat0_instr",
  "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "cat1_opc", "cat1_src",
  "cat1_movmsk", "$@19", "cat1_mova1", "$@20", "cat1_mova", "$@21",
  "cat1_swz", "$@22", "cat1_gat", "$@23", "cat1_sct", "$@24", "cat1_instr",
  "cat2_opc_1src", "cat2_opc_2src_cnd", "cat2_opc_2src", "cond",
  "cat2_instr", "cat3_dp_signedness", "cat3_dp_pack", "cat3_opc",
  "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp", "cat3_instr", "cat4_opc",
  "cat4_instr", "cat5_opc_dsxypp", "cat5_opc", "cat5_flag", "cat5_flags",
  "cat5_samp", "cat5_tex", "cat5_type", "cat5_a1", "cat5_instr",
  "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset", "cat6_offset",
  "cat6_dst_offset", "cat6_immed", "cat6_stg_ldg_a6xx_offset", "cat6_load",
  "$@25", "$@26", "$@27", "$@28", "$@29", "$@30", "$@31", "cat6_store",
  "$@32", "$@33", "$@34", "$@35", "$@36", "cat6_loadib", "$@37",
  "cat6_storeib", "$@38", "cat6_prefetch", "$@39", "cat6_atomic_opc",
  "cat6_a3xx_atomic_opc", "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s",
  "cat6_a6xx_atomic_g", "cat6_atomic_l", "cat6_atomic",
  "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb", "cat6_ibo_opc_stgb",
  "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id", "cat6_bindless_base",
  "cat6_bindless_mode", "cat6_reg_or_immed", "cat6_bindless_ibo_opc_1src",
  "cat6_bindless_ibo_opc_2src", "cat6_bindless_ibo_opc_2src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle",
  "cat6_bindless_ldc", "stc_dst", "cat6_stc", "$@41", "cat6_todo",
  "cat6_instr", "cat7_scope", "cat7_scopes", "cat7_barrier", "$@42",
  "$@43", "cat7_instr", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "offset", "relative_gpr_src",
  "relative_gpr_dst", "relative_const", "relative", "immediate_cat1",
  "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,    45,    44,
      40,    41,    61,    58,    33,    35,    46,    97,   111,   112,
     115,    43,    60,   103,    91,    93,   108,   107,    99,   119,
     114,    62,   104
};
# endif

#define YYPACT_NINF -867

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-867)))

#define YYTABLE_NINF -4

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -867,    24,   867,  -867,    55,  -290,    55,  -288,  -274,  -255,
      55,  -220,  -218,  -182,    55,  -867,   778,   867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,    94,  -173,   152,  -867,   158,   209,   163,
    -867,   170,   185,   189,  -867,  -124,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,   844,  1118,   659,  -867,  -867,  -867,  -867,
      55,  -116,  -107,   -79,   -49,   -32,   -19,   -18,   -17,   -15,
    -867,  -867,  -867,  -867,  -867,  -867,   -14,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,   -11,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,    -2,    -7,     4,    -1,    27,    31,    32,
      33,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,    20,  -867,  -867,  -867,  -867,  -867,  -867,  -867,   233,
      35,   233,  -867,   233,   233,   233,    40,  -867,   233,  -867,
      46,    46,  -867,  -867,  -867,  -867,  -867,  -867,    65,    65,
      65,  -867,  -867,  -867,  -867,    72,    65,    65,  -867,    72,
    -867,    65,    65,    65,  -867,    78,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,    89,    55,   347,  -867,  -867,  -867,  -867,
    -867,   400,   403,   406,  -152,  -152,  -152,    34,  -152,  -152,
      96,    96,    96,  -152,    96,   103,    96,    96,  -152,  -152,
     114,   120,   123,   118,   126,   128,   137,   144,    72,    72,
      72,    72,    72,    72,    72,    72,    65,   122,    72,    72,
      65,    72,    72,   136,   136,  -867,   133,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,   134,  -867,   481,    -4,   149,
     150,   154,   -48,   159,   161,   165,   166,   -52,   155,   167,
     545,    46,   233,   171,    -9,   156,   156,   156,   583,   156,
     156,   156,   233,   156,   156,   156,     9,    55,   175,   169,
     178,   179,   173,  -867,   190,   181,   203,   204,  -867,  -867,
     293,  -867,   205,   208,    49,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,   233,   233,   233,   233,   202,   212,   168,
     207,   156,   215,   233,   206,   156,   233,   213,  -109,   136,
    -867,  -867,   237,   239,  -867,  -867,   315,   315,   723,  -867,
    -867,  -867,  -867,  -867,  -867,   233,   723,   110,   776,   157,
    -867,  -867,     8,   233,   723,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,   242,   583,   233,  -867,
    -867,   221,    72,    72,    72,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,   233,    72,    72,  -867,    72,    72,
      72,   230,   232,   243,  -867,  -867,    55,  -867,   553,   557,
      34,  -867,    96,  -122,  -122,  -867,  -867,    96,    96,    96,
    -867,  -867,    96,   233,   315,   315,   233,   233,   233,   245,
     247,   248,   249,   235,   236,   238,   253,    72,    29,   257,
     263,    72,   258,   264,  -867,  -867,  -867,  -867,  -867,  -223,
    -223,  -867,  -867,  -867,  -867,  -867,  -867,   269,   270,  -867,
    -867,  -867,     2,   271,   272,   259,  -867,  -867,  -867,   508,
     240,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,    34,   116,    36,  -867,  -867,  -867,  -867,
    -867,   262,   286,   288,    29,  -867,   289,  -867,  -867,  -867,
     290,  -867,  -867,  -867,   291,  -867,   358,   295,   298,  -867,
    -867,  -867,  -867,   294,   300,   301,   302,   305,   306,   308,
     310,   311,    34,   277,   100,   320,   319,   322,   321,  -867,
    -867,   330,   327,   332,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,   333,   344,   348,   335,   336,   334,   337,    29,    29,
      29,    29,   354,  -222,   349,    29,   363,   356,   102,    34,
      34,   352,   357,   377,   382,  -867,   378,   379,   218,   380,
     389,   399,   404,   139,  -867,  -867,  -867,  -867,   392,    34,
    -867,  -867,   723,   723,   162,   162,   358,   776,  -867,  -867,
     188,    34,    34,    34,   383,    34,    34,    34,    34,    34,
     395,   396,   409,  -867,  -867,    55,    34,    34,   712,  -867,
      96,    96,   233,   358,   233,   391,   398,   402,   405,  -223,
     410,  -144,  -144,    34,   100,  -867,   388,  -867,   408,  -144,
      34,   416,   420,   394,  -867,  -867,  -867,  -867,  -867,  -223,
    -223,  -867,  -867,  -867,  -867,  -867,  -223,  -223,   412,   413,
    -867,   419,   434,  -867,    56,   435,   448,   451,   452,  -867,
    -867,   453,  -867,   454,   449,   455,   456,   458,   233,  -867,
     459,   461,   462,    37,    37,   100,   474,   473,   475,   482,
    -867,  -867,   484,   486,   487,    29,    29,    29,    29,   485,
     138,   494,   100,   497,  -867,   498,   233,  -867,   502,    29,
     499,   504,    34,    34,   519,   500,   503,   509,   511,  -867,
    -867,  -867,   723,   110,   776,    87,   162,   534,   188,   513,
     522,   523,   100,   538,   525,    37,    37,    37,   544,   544,
     544,   233,   533,  -867,    55,  -867,  -867,    34,   358,   358,
     233,  -222,   410,  -222,  -222,   541,    29,   564,   578,  -867,
     588,   589,   590,    34,  -222,   591,   568,   576,  -867,   358,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,   593,  -867,
     594,  -867,   595,   233,   233,   233,   580,   584,   585,   233,
     358,   233,   612,  -867,  -867,  -867,  -867,   586,  -867,   602,
     603,   606,   607,   592,   596,   597,   601,    29,  -223,   598,
      29,    29,    29,   604,  -867,   605,    29,    87,  -867,   610,
     776,   260,   188,   622,   623,   625,  -867,   611,   100,   627,
     629,   630,  -867,   636,   945,   358,   358,   233,   634,   635,
     644,   645,   648,   649,    34,   652,   653,   654,   640,   656,
     657,   642,   660,    34,  -867,  -867,  -867,  -867,   661,  -867,
    -867,   646,   650,    29,   100,   643,   100,   100,   100,   651,
     662,  -867,   666,   668,    87,    87,    87,    87,    87,   658,
    -223,    87,    87,    87,    87,    87,    87,   669,    87,  -867,
     260,   647,   655,   672,   663,   673,  -867,   674,   675,  -867,
      34,   358,   358,  -867,  -867,  -867,  -867,  -867,   664,   665,
    -867,  -867,  -867,   667,  -867,  -867,    29,  -867,  -867,  -867,
     100,   100,    29,   676,    29,   100,   100,   680,  -867,  -867,
      34,   671,   681,   682,   670,   677,  -867,    29,   685,  -867,
    -867,  1000,  -867,    34,    29,    29,   688,   689,   690,   100,
     691,  -867,   692,   695,    29,    29,    29,   696,    34,    29,
      29,  -867,   697,  -867,    29,   698,  -867,  -867,    29,  -867,
    1004,   699,   700,    29,    34,  -867,  -867
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    45,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    26,     0,     0,     0,
      32,     0,     0,     0,    33,     0,    38,    39,    40,    41,
      42,    43,    44,    45,     0,    45,    48,    57,     5,    20,
       0,     0,    25,     0,     0,     0,     0,     0,     0,     0,
      58,    46,    65,    66,    68,    70,     0,    74,    76,    78,
      80,    82,    84,    85,    87,    88,    89,    90,    91,    92,
      93,    95,    96,    97,    98,     0,    99,   101,   102,   104,
     105,   107,   109,     0,     0,     0,     0,     0,     0,     0,
       0,   156,   157,   158,   159,   140,   150,   136,   153,   141,
     142,   143,   144,   145,   160,   161,   162,   163,   151,   152,
     164,   165,   166,   167,   137,   168,   169,   146,   170,   154,
     155,   171,   172,   173,   147,   139,   138,   174,   175,   176,
     177,   178,   179,   180,   148,   149,   181,   182,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   219,
     220,   217,   218,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   236,   237,   262,
     263,   264,   265,   266,   267,   268,   316,   318,   322,   320,
     329,   331,   335,   333,   339,   428,   429,   343,   324,   337,
     430,   384,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   402,   415,   414,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   385,
     386,   341,   419,   326,   391,   392,   393,   426,   449,   451,
      49,     0,   128,   129,   130,   131,   132,   133,    50,     0,
       0,     0,    51,     0,     0,     0,     0,    52,     0,    53,
     279,   279,    54,   431,   433,   432,   434,   435,     0,     0,
       0,   382,   383,   381,   436,     0,     0,     0,   437,     0,
     438,     0,     0,     0,   440,     0,   439,   441,   442,    55,
     453,    56,    47,     0,     0,     0,    27,    28,    29,    30,
      31,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   447,   447,   458,     0,   463,   464,   465,
     466,   467,   459,   460,   461,     0,   470,   468,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   279,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    60,     0,     0,     0,     0,   530,   532,
       0,    72,     0,     0,     0,    79,    81,    83,    86,    94,
     110,   100,   103,   106,   108,   116,   118,   120,   112,   113,
     122,   124,   126,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   447,
     450,   452,     0,     0,   469,   471,     0,     0,     0,   183,
     184,   185,   186,   187,   188,     0,     0,     0,     0,     0,
     192,   193,     0,     0,     0,   269,   274,   277,   275,   276,
     278,   270,   271,   272,   273,   280,     0,     0,     0,   301,
     302,     0,     0,     0,     0,   536,   537,   538,   539,   540,
     541,   542,   543,   307,     0,     0,     0,   394,     0,     0,
       0,     0,     0,     0,   313,    22,     0,    24,     0,     0,
       0,    59,     0,     0,     0,   531,   533,     0,     0,     0,
      64,    63,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   446,   445,   443,   444,   448,   495,
     495,   454,   462,   472,   473,   474,   475,     0,     0,   455,
     456,   457,     0,     0,     0,     0,   134,   478,   482,   476,
       0,   484,   485,   486,   114,   504,   505,   487,   115,   506,
     135,   518,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,     0,     0,     0,   489,   189,   491,   515,
     513,     0,     0,     0,     0,   492,     0,   493,   494,   480,
       0,   481,   194,   195,     0,   235,     0,     0,   300,   303,
     304,   305,   306,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    67,
      62,     0,     0,     0,    73,    75,    77,   111,   117,   119,
     121,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   534,     0,     0,     0,     0,
       0,     0,     0,     0,   477,   479,   483,   488,     0,     0,
     517,   490,     0,     0,     0,     0,     0,     0,   285,   283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   400,   401,     0,     0,     0,     0,    61,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   495,
       0,   495,   495,     0,     0,   309,     0,   308,     0,   495,
       0,     0,   424,     0,   423,   497,   496,   501,   500,   495,
     495,   511,   512,   535,   507,   508,   495,   495,     0,     0,
     514,     0,     0,   191,     0,     0,     0,     0,     0,   281,
     282,   298,   299,   296,     0,     0,     0,     0,     0,   389,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      69,    71,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   311,     0,     0,   310,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   509,
     510,   516,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   395,   395,
     395,     0,     0,   422,     0,    35,    36,     0,     0,     0,
       0,   495,     0,   495,   495,     0,     0,     0,     0,   312,
       0,     0,     0,     0,   495,     0,     0,     0,   425,     0,
     499,   503,   502,   498,   190,   221,   222,   223,     0,   297,
     294,   295,   291,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   398,   399,   397,   420,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   495,     0,
       0,     0,     0,     0,   344,     0,     0,     0,   327,     0,
       0,     0,     0,     0,     0,     0,   387,     0,     0,     0,
       0,     0,   396,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   224,   292,   293,   284,   289,   290,
     286,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
     495,     0,     0,     0,     0,     0,     0,     0,     0,   427,
       0,     0,     0,     0,     0,     0,   416,     0,     0,   421,
       0,     0,     0,   317,   319,   323,   321,   330,     0,     0,
     332,   336,   334,     0,   325,   338,     0,   328,   287,   288,
       0,     0,     0,     0,     0,     0,     0,     0,   125,   127,
       0,     0,     0,     0,     0,     0,   379,     0,     0,   417,
     418,     0,   314,     0,     0,     0,     0,     0,     0,     0,
       0,   315,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   380,     0,   388,     0,     0,   340,   342,     0,   390,
       0,     0,     0,     0,     0,   378,    37
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -867,  -867,  -867,  1002,  -867,    -6,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,   967,  -867,   966,  -867,   318,   450,  -343,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -472,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -234,  -866,  -806,
    -867,   -27,  -867,   282,   -51,   567,   241,  -656,  -700,  -492,
     113,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -614,  -729,  -250,  -867,  -867,
    -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,  -867,
    -867,  -389,  -867,  -867,  -867,  -867,  -181,   608,  -544,  -867,
     614,  -295,  -867,  -423,  -462,  -867,  -867,  -713,  -496,  -507,
    -690,  -584,   510,  -867,  -867,  -516,  -867,  -452,   373,  -366,
     285,   495
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,    16,    17,    34,    18,    19,   356,    20,
      62,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      53,    54,    55,    56,    57,   455,   702,   465,   300,   364,
     365,   366,   577,   368,   369,   370,   371,   372,   373,   374,
     376,   377,   378,   379,   582,   301,   626,   302,   583,   303,
     584,   304,   585,   305,   586,   306,   587,   307,   588,   308,
     309,   310,   311,   515,   312,   428,   523,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   431,   432,   831,   832,
     538,  1016,   322,   435,   542,   439,   795,   796,   863,   562,
     861,   323,   388,   389,   391,   390,   398,   401,  1012,   324,
     392,   393,   395,   394,   399,   325,   396,   326,   400,   327,
     397,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   894,   339,   340,   953,   901,   772,   341,   342,
     343,   344,   345,   563,   346,   803,   347,   402,   348,   349,
     499,   500,   350,   403,   404,   351,   627,   416,   628,   417,
     418,   419,   629,   664,   631,   670,   632,   633,   656,   657,
     666,   797,   635,   420,   636,   637,   638,   658,   659,   660,
     740,   553
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   461,   667,   405,    40,   458,   459,   735,    44,   662,
     634,   634,   458,   459,   421,   501,   423,   675,   424,   425,
     426,   663,   940,   429,     3,   731,   732,   405,   466,   467,
      35,   469,    37,   471,   472,   640,   611,   458,   459,   458,
     459,   825,   826,   611,   612,   406,    38,   407,   408,   409,
     410,   411,   458,   459,   353,   580,   665,   669,    30,    31,
      32,   617,   618,   611,   612,    39,   668,   828,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     564,   939,   941,   630,   630,   655,   746,   433,   634,   634,
     458,   459,   865,   655,   630,   729,   729,    59,   581,   870,
      41,   655,    42,   458,   459,   458,   459,   611,   730,   794,
     608,   746,   709,   710,   747,   902,  1018,   611,   612,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   613,   614,   615,   616,   617,   618,   536,    43,   747,
     639,   639,   458,   459,   735,   611,    60,   557,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
      61,   630,   630,   453,   611,    63,   949,   950,   951,   611,
     612,    66,   454,   938,   729,  1015,  1019,    67,   613,   614,
     615,   616,   617,   613,   614,   615,   616,   862,   589,   590,
     591,   592,    68,   700,   936,   611,    69,   535,   599,    70,
     770,   602,   701,   751,   698,   354,   744,   864,   864,   613,
     614,   615,   616,   355,   758,   864,    64,    65,   639,   639,
     661,   575,   576,   813,   604,   875,   876,   605,   674,   699,
     606,   607,   877,   878,   704,   705,   706,   520,   521,   707,
     405,   667,   357,   678,  1078,   822,   823,   611,   612,   509,
     510,   511,   512,   513,   514,   963,   739,   965,   966,   686,
     407,   408,   409,   410,   411,   617,   618,   611,   975,   834,
     835,   836,   358,   838,   839,   840,   841,   842,   539,   540,
     746,   613,   614,   615,   616,   954,   955,   748,   708,   359,
    1014,   711,   712,   713,   827,   665,   575,   576,   833,   672,
     673,   866,   360,   361,   362,   668,   363,   381,   871,   412,
     413,   414,   367,   736,   737,   375,   561,   382,   458,   459,
     738,   853,   611,   612,   380,   383,   564,   460,   774,   655,
     655,   824,   824,   412,   413,   414,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   898,   899,   900,   448,   619,
     620,   621,   460,   384,   460,   449,   653,   385,   386,   387,
     415,   422,   804,   805,   806,   611,   427,   460,   667,   619,
     620,   621,   430,    33,   623,   934,   624,   818,   654,   613,
     614,   615,   616,   821,  1003,   543,   544,   935,   554,   555,
     556,   434,   558,   559,   560,   564,   564,   564,   438,   564,
     564,   564,   564,   564,   446,   460,   450,   653,   447,   451,
     847,   848,   452,   619,   620,   621,   802,   723,   460,   470,
     460,   464,   665,   619,   620,   621,   942,   564,   806,   654,
     475,   974,   668,   937,   564,   478,   749,   850,   851,   476,
     597,   565,   477,   479,   601,   480,   960,   961,   623,   745,
     624,   619,   620,   621,   481,   492,  1069,   738,   916,   655,
     630,   482,   498,   824,   667,   502,   503,   979,   506,   507,
     619,   620,   621,   508,   745,   619,   620,   621,   516,   774,
     517,   522,   541,   745,   518,   519,   524,   852,   990,   854,
     567,   537,   829,   830,   566,   570,   806,   624,   568,   569,
     572,   619,   620,   621,   595,   571,   927,   928,   407,   408,
     409,   410,   411,   773,   679,   680,   681,   682,   665,  1017,
    1020,  1049,   573,   574,   578,  1011,   774,   579,   668,   613,
     614,   615,   616,  1031,  1032,   593,   596,   789,   790,   791,
     792,   959,   600,   893,   799,   594,   412,   413,   414,   598,
     609,   603,   610,   619,   620,   621,   692,   564,   693,   696,
     695,   676,   694,   697,   714,   830,   715,   716,   717,   718,
     719,   922,   720,   619,   620,   621,   724,   727,   623,   743,
     624,   752,  1063,  1064,  1065,  1066,  1067,   721,  1017,  1070,
    1071,  1072,  1073,  1074,  1075,   903,  1077,   725,   728,  1088,
    1089,   733,   734,   741,   742,   753,   956,   754,   755,   756,
     757,   436,   437,   867,   771,   962,   759,   760,   440,   441,
     761,   764,   774,   443,   444,   445,   762,   763,   619,   620,
     621,   765,   766,   460,   767,   622,   768,   769,  1040,   775,
     778,   776,   946,   745,   777,   779,   780,   564,   983,   984,
     985,   781,   782,   623,   989,   624,   991,   625,   774,    -3,
     774,   774,   774,   783,   773,    45,   788,   784,   785,   786,
     787,   619,   620,   621,   911,   912,   913,   914,   491,   917,
     793,   919,   495,   456,   457,   798,   462,   463,   924,   800,
     809,   468,   801,   807,  1087,   810,   473,   474,   808,   811,
     812,   814,  1033,    46,    47,    48,    49,    50,    51,    52,
     815,   773,   816,   820,   774,   774,   837,   817,   849,   774,
     774,   843,   844,   868,  1102,   855,   458,   459,   845,   874,
     611,   612,   856,   879,   880,   968,   857,  1111,  1025,   858,
     881,   860,   869,   774,   613,   614,   615,   616,   617,   618,
     872,   873,  1125,   882,   883,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   884,  1136,   846,
     885,   886,   887,   888,  1054,   889,  1056,  1057,  1058,   458,
     459,   890,   891,   611,    45,   895,  1002,   896,   897,  1005,
    1006,  1007,   892,   904,   905,  1010,   906,   613,   614,   615,
     616,   617,   618,   908,   907,   909,   910,   773,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     915,   923,    46,    47,    48,    49,    50,    51,    52,   918,
    1094,  1095,   920,   921,   925,  1099,  1100,   926,   929,   830,
     525,   930,  1053,   773,   931,   773,   773,   773,   526,   943,
     932,   527,   933,   528,   529,   944,   945,   947,   948,  1117,
     967,   530,   545,   546,   547,   548,   549,   550,   551,   552,
     952,   957,   531,   532,   533,   534,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    46,    47,
      48,    49,    50,    51,    52,  1093,   969,   970,   958,   773,
     773,  1096,   977,  1098,   773,   773,   442,   971,   972,   973,
     976,   978,   980,   981,   982,   986,  1108,   987,   992,   988,
     993,   994,   995,  1112,  1113,   996,   997,   998,   773,  1013,
    1004,   999,  1000,  1121,  1122,  1123,  1001,  1008,  1126,  1127,
    1009,  1021,  1022,  1129,  1023,  1024,  1026,  1131,  1027,  1028,
    1029,  1030,  1135,  1034,  1035,   483,   484,   485,   486,   487,
     488,   489,   490,  1036,  1037,   493,   494,  1038,   496,   497,
    1039,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1055,  1048,
    1050,  1080,  1051,  1052,  1060,  1061,  1059,  1062,  1076,  1081,
    1068,  1082,  1084,  1085,  1086,  1097,  1090,  1091,  1083,  1101,
    1104,  1105,  1092,  1103,  1109,  1106,  1110,  1114,  1115,  1116,
    1132,  1119,  1107,  1118,  1120,  1124,  1128,  1130,  1133,    58,
      71,   352,  1134,  1079,   703,   964,   505,   750,   819,   671,
     859,   504,   677,     0,     0,     0,   619,   620,   621,     0,
       0,   460,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   623,     0,   624,     0,   654,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   619,
     620,   621,     0,     0,   460,     0,   653,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   683,
     684,   685,     0,     0,   623,     0,   624,     0,   654,     0,
       0,     0,   687,   688,     0,   689,   690,   691,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   722,     0,     0,     0,   726,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299
};

static const yytype_int16 yycheck[] =
{
       6,   367,   518,     7,    10,     3,     4,     5,    14,   516,
     506,   507,     3,     4,   309,   404,   311,   524,   313,   314,
     315,   517,   888,   318,     0,   609,   610,     7,   371,   372,
     320,   374,   320,   376,   377,   507,     7,     3,     4,     3,
       4,   754,   755,     7,     8,    25,   320,    27,    28,    29,
      30,    31,     3,     4,    60,     6,   518,   519,     3,     4,
       5,    25,    26,     7,     8,   320,   518,   757,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
     446,   887,   888,   506,   507,   508,   630,   321,   584,   585,
       3,     4,   792,   516,   517,   318,   318,     3,   464,   799,
     320,   524,   320,     3,     4,     3,     4,     7,   331,   331,
     499,   655,   584,   585,   630,   844,   982,     7,     8,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    21,    22,    23,    24,    25,    26,   432,   320,   655,
     506,   507,     3,     4,     5,     7,   319,   442,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
       8,   584,   585,   315,     7,     7,   895,   896,   897,     7,
       8,     8,   324,   886,   318,   981,   982,     7,    21,    22,
      23,    24,    25,    21,    22,    23,    24,   331,   483,   484,
     485,   486,     7,   315,   884,     7,     7,   431,   493,   323,
     692,   496,   324,   655,   570,   321,   629,   791,   792,    21,
      22,    23,    24,   320,   676,   799,     7,     8,   584,   585,
     515,     3,     4,     5,   333,   809,   810,   336,   523,   572,
     339,   340,   816,   817,   577,   578,   579,   289,   290,   582,
       7,   757,   321,   538,  1050,   752,   753,     7,     8,   297,
     298,   299,   300,   301,   302,   911,   622,   913,   914,   554,
      27,    28,    29,    30,    31,    25,    26,     7,   924,   761,
     762,   763,   321,   765,   766,   767,   768,   769,   287,   288,
     824,    21,    22,    23,    24,   899,   900,   653,   583,   321,
     980,   586,   587,   588,   756,   757,     3,     4,   760,   291,
     292,   793,   321,   321,   321,   757,   321,   314,   800,   313,
     314,   315,   326,   311,   312,   326,   307,   313,     3,     4,
     318,   783,     7,     8,   326,   326,   692,   318,   694,   752,
     753,   754,   755,   313,   314,   315,    21,    22,    23,    24,
      25,    26,   313,   314,   315,   308,   309,   310,   354,   313,
     314,   315,   318,   326,   318,     8,   320,   326,   326,   326,
     340,   326,   728,   729,   730,     7,   326,   318,   884,   313,
     314,   315,   326,   318,   338,   882,   340,   743,   342,    21,
      22,    23,    24,   749,   968,   436,   437,   883,   439,   440,
     441,   326,   443,   444,   445,   761,   762,   763,   326,   765,
     766,   767,   768,   769,   326,   318,     6,   320,   319,     6,
     776,   777,     6,   313,   314,   315,   314,   598,   318,   316,
     318,   325,   884,   313,   314,   315,   888,   793,   794,   342,
     316,   923,   884,   885,   800,   317,   320,   780,   781,   319,
     491,   447,   319,   317,   495,   317,   908,   909,   338,   630,
     340,   313,   314,   315,   317,   333,  1040,   318,   320,   882,
     883,   317,   326,   886,   980,   332,   332,   929,   319,   319,
     313,   314,   315,   319,   655,   313,   314,   315,   319,   845,
     319,   326,   326,   664,   319,   319,   319,   782,   950,   784,
     321,   320,   304,   305,   319,   322,   862,   340,   320,   320,
     319,   313,   314,   315,   336,   315,   872,   873,    27,    28,
      29,    30,    31,   694,   293,   294,   295,   296,   980,   981,
     982,  1013,   319,   319,   319,   977,   892,   319,   980,    21,
      22,    23,    24,   995,   996,   333,   329,   718,   719,   720,
     721,   907,   336,   838,   725,   333,   313,   314,   315,   334,
     313,   338,   313,   313,   314,   315,   326,   923,   326,     6,
     566,   319,   319,     6,   319,   305,   319,   319,   319,   334,
     334,   866,   334,   313,   314,   315,   319,   319,   338,   320,
     340,   319,  1034,  1035,  1036,  1037,  1038,   334,  1050,  1041,
    1042,  1043,  1044,  1045,  1046,   845,  1048,   334,   334,  1061,
    1062,   332,   332,   332,   332,   319,   901,   319,   319,   319,
     319,   329,   330,   794,   337,   910,   321,   319,   336,   337,
     326,   319,   988,   341,   342,   343,   326,   326,   313,   314,
     315,   326,   326,   318,   326,   320,   326,   326,  1004,   319,
     319,   322,   892,   824,   322,   315,   319,  1013,   943,   944,
     945,   319,   319,   338,   949,   340,   951,   342,  1024,     0,
    1026,  1027,  1028,   319,   845,     6,   329,   319,   333,   333,
     336,   313,   314,   315,   855,   856,   857,   858,   396,   860,
     326,   862,   400,   365,   366,   336,   368,   369,   869,   326,
     313,   373,   336,   341,  1060,   313,   378,   379,   341,   321,
     321,   321,   997,    44,    45,    46,    47,    48,    49,    50,
     321,   892,   313,   321,  1080,  1081,   333,   313,     6,  1085,
    1086,   326,   326,   335,  1090,   334,     3,     4,   319,   335,
       7,     8,   334,   321,   321,   916,   334,  1103,   988,   334,
     321,   331,   334,  1109,    21,    22,    23,    24,    25,    26,
     334,   331,  1118,   319,   319,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,   319,  1134,   775,
     319,   319,   319,   319,  1024,   326,  1026,  1027,  1028,     3,
       4,   326,   326,     7,     6,   326,   967,   326,   326,   970,
     971,   972,   334,   319,   321,   976,   321,    21,    22,    23,
      24,    25,    26,   319,   322,   319,   319,   988,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
     335,   319,    44,    45,    46,    47,    48,    49,    50,   335,
    1080,  1081,   335,   335,   335,  1085,  1086,   333,   319,   305,
     295,   341,  1023,  1024,   341,  1026,  1027,  1028,   303,   336,
     341,   306,   341,   308,   309,   333,   333,   319,   333,  1109,
     319,   316,   279,   280,   281,   282,   283,   284,   285,   286,
     326,   338,   327,   328,   329,   330,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    44,    45,
      46,    47,    48,    49,    50,  1076,   332,   319,   904,  1080,
    1081,  1082,   334,  1084,  1085,  1086,   339,   319,   319,   319,
     319,   335,   319,   319,   319,   335,  1097,   333,   306,   334,
     334,   319,   319,  1104,  1105,   319,   319,   335,  1109,   319,
     332,   335,   335,  1114,  1115,  1116,   335,   333,  1119,  1120,
     335,   319,   319,  1124,   319,   334,   319,  1128,   319,   319,
     314,     6,  1133,   319,   319,   388,   389,   390,   391,   392,
     393,   394,   395,   319,   319,   398,   399,   319,   401,   402,
     321,   319,   319,   319,   334,   319,   319,   335,   335,   319,
     319,   334,   336,   333,   322,   319,   335,   319,   319,   334,
     332,   319,   319,   319,   319,   319,   332,   332,   335,   319,
     319,   319,   335,   332,   319,   335,     6,   319,   319,   319,
       6,   319,   335,   322,   319,   319,   319,   319,   319,    17,
      53,    55,   322,  1050,   574,   912,   418,   654,   743,   519,
     789,   417,   537,    -1,    -1,    -1,   313,   314,   315,    -1,
      -1,   318,    -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   338,    -1,   340,    -1,   342,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   313,
     314,   315,    -1,    -1,   318,    -1,   320,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   542,
     543,   544,    -1,    -1,   338,    -1,   340,    -1,   342,    -1,
      -1,    -1,   555,   556,    -1,   558,   559,   560,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   597,    -1,    -1,    -1,   601,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   344,   345,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   346,   347,   349,   350,
     352,   354,   355,   356,   357,   358,   359,   360,   361,   362,
       3,     4,     5,   318,   348,   320,   348,   320,   320,   320,
     348,   320,   320,   320,   348,     6,    44,    45,    46,    47,
      48,    49,    50,   363,   364,   365,   366,   367,   346,     3,
     319,     8,   353,     7,     7,     8,     8,     7,     7,     7,
     323,   364,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     371,   388,   390,   392,   394,   396,   398,   400,   402,   403,
     404,   405,   407,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   425,   434,   442,   448,   450,   452,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   466,
     467,   471,   472,   473,   474,   475,   477,   479,   481,   482,
     485,   488,   366,   348,   321,   320,   351,   321,   321,   321,
     321,   321,   321,   321,   372,   373,   374,   326,   376,   377,
     378,   379,   380,   381,   382,   326,   383,   384,   385,   386,
     326,   314,   313,   326,   326,   326,   326,   326,   435,   436,
     438,   437,   443,   444,   446,   445,   449,   453,   439,   447,
     451,   440,   480,   486,   487,     7,    25,    27,    28,    29,
      30,    31,   313,   314,   315,   340,   490,   492,   493,   494,
     506,   494,   326,   494,   494,   494,   494,   326,   408,   494,
     326,   419,   420,   420,   326,   426,   426,   426,   326,   428,
     426,   426,   428,   426,   426,   426,   326,   319,   348,     8,
       6,     6,     6,   315,   324,   368,   368,   368,     3,     4,
     318,   512,   368,   368,   325,   370,   370,   370,   368,   370,
     316,   370,   370,   368,   368,   316,   319,   319,   317,   317,
     317,   317,   317,   428,   428,   428,   428,   428,   428,   428,
     428,   426,   333,   428,   428,   426,   428,   428,   326,   483,
     484,   484,   332,   332,   493,   490,   319,   319,   319,   297,
     298,   299,   300,   301,   302,   406,   319,   319,   319,   319,
     289,   290,   326,   409,   319,   295,   303,   306,   308,   309,
     316,   327,   328,   329,   330,   420,   494,   320,   423,   287,
     288,   326,   427,   427,   427,   279,   280,   281,   282,   283,
     284,   285,   286,   514,   427,   427,   427,   494,   427,   427,
     427,   307,   432,   476,   512,   348,   319,   321,   320,   320,
     322,   315,   319,   319,   319,     3,     4,   375,   319,   319,
       6,   512,   387,   391,   393,   395,   397,   399,   401,   494,
     494,   494,   494,   333,   333,   336,   329,   427,   334,   494,
     336,   427,   494,   338,   333,   336,   339,   340,   484,   313,
     313,     7,     8,    21,    22,    23,    24,    25,    26,   313,
     314,   315,   320,   338,   340,   342,   389,   489,   491,   495,
     496,   497,   499,   500,   501,   505,   507,   508,   509,   512,
     389,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   320,   342,   496,   501,   502,   510,   511,
     512,   494,   502,   501,   496,   497,   503,   508,   510,   497,
     498,   505,   291,   292,   494,   502,   319,   514,   494,   293,
     294,   295,   296,   428,   428,   428,   494,   428,   428,   428,
     428,   428,   326,   326,   319,   348,     6,     6,   512,   370,
     315,   324,   369,   369,   370,   370,   370,   370,   494,   389,
     389,   494,   494,   494,   319,   319,   319,   319,   334,   334,
     334,   334,   428,   489,   319,   334,   428,   319,   334,   318,
     331,   504,   504,   332,   332,     5,   311,   312,   318,   512,
     513,   332,   332,   320,   496,   489,   491,   508,   512,   320,
     511,   510,   319,   319,   319,   319,   319,   319,   497,   321,
     319,   326,   326,   326,   319,   326,   326,   326,   326,   326,
     432,   337,   470,   489,   512,   319,   322,   322,   319,   315,
     319,   319,   319,   319,   319,   333,   333,   336,   329,   489,
     489,   489,   489,   326,   331,   429,   430,   504,   336,   489,
     326,   336,   314,   478,   512,   512,   512,   341,   341,   313,
     313,   321,   321,     5,   321,   321,   313,   313,   512,   513,
     321,   512,   502,   502,   496,   500,   500,   497,   503,   304,
     305,   421,   422,   497,   432,   432,   432,   333,   432,   432,
     432,   432,   432,   326,   326,   319,   348,   512,   512,     6,
     370,   370,   494,   497,   494,   334,   334,   334,   334,   429,
     331,   433,   331,   431,   504,   431,   432,   489,   335,   334,
     431,   432,   334,   331,   335,   504,   504,   504,   504,   321,
     321,   321,   319,   319,   319,   319,   319,   319,   319,   326,
     326,   326,   334,   494,   465,   326,   326,   326,   308,   309,
     310,   469,   469,   470,   319,   321,   321,   322,   319,   319,
     319,   489,   489,   489,   489,   335,   320,   489,   335,   489,
     335,   335,   494,   319,   489,   335,   333,   512,   512,   319,
     341,   341,   341,   341,   502,   501,   503,   510,   500,   422,
     421,   422,   497,   336,   333,   333,   470,   319,   333,   469,
     469,   469,   326,   468,   468,   468,   494,   338,   348,   512,
     497,   497,   494,   430,   433,   430,   430,   319,   489,   332,
     319,   319,   319,   319,   432,   430,   319,   334,   335,   497,
     319,   319,   319,   494,   494,   494,   335,   333,   334,   494,
     497,   494,   306,   334,   319,   319,   319,   319,   335,   335,
     335,   335,   489,   504,   332,   489,   489,   489,   333,   335,
     489,   510,   441,   319,   503,   422,   424,   497,   421,   422,
     497,   319,   319,   319,   334,   470,   319,   319,   319,   314,
       6,   497,   497,   494,   319,   319,   319,   319,   319,   321,
     512,   319,   319,   319,   334,   319,   319,   335,   319,   432,
     319,   336,   333,   489,   470,   335,   470,   470,   470,   335,
     322,   319,   319,   510,   510,   510,   510,   510,   332,   504,
     510,   510,   510,   510,   510,   510,   319,   510,   422,   424,
     334,   334,   319,   335,   319,   319,   319,   512,   497,   497,
     332,   332,   335,   489,   470,   470,   489,   319,   489,   470,
     470,   319,   512,   332,   319,   319,   335,   335,   489,   319,
       6,   512,   489,   489,   319,   319,   319,   470,   322,   319,
     319,   489,   489,   489,   319,   512,   489,   489,   319,   489,
     319,   489,     6,   319,   322,   489,   512
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   343,   345,   344,   346,   346,   347,   347,   347,   347,
     347,   347,   347,   347,   347,   347,   347,   347,   348,   348,
     348,   348,   349,   350,   351,   351,   353,   352,   354,   355,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   363,
     363,   363,   363,   363,   363,   364,   364,   365,   365,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   367,   368,
     368,   369,   369,   370,   370,   371,   372,   371,   373,   371,
     374,   371,   375,   371,   376,   371,   377,   371,   378,   371,
     379,   371,   380,   371,   371,   381,   371,   371,   371,   371,
     371,   371,   371,   382,   371,   371,   371,   371,   371,   383,
     371,   371,   384,   371,   371,   385,   371,   386,   371,   371,
     387,   371,   388,   388,   389,   389,   391,   390,   393,   392,
     395,   394,   397,   396,   399,   398,   401,   400,   402,   402,
     402,   402,   402,   402,   402,   402,   403,   403,   403,   403,
     403,   403,   403,   403,   403,   403,   403,   403,   403,   403,
     404,   404,   404,   404,   404,   404,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   405,   405,   405,   405,   405,   405,   405,
     405,   405,   405,   406,   406,   406,   406,   406,   406,   407,
     407,   407,   408,   408,   409,   409,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   410,   410,   410,   410,   410,
     410,   410,   411,   411,   411,   411,   411,   412,   412,   413,
     413,   414,   414,   414,   414,   415,   415,   415,   415,   415,
     415,   415,   415,   415,   415,   416,   417,   417,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   420,
     420,   421,   422,   423,   424,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   426,   426,   427,   427,   427,   427,   428,   429,   430,
     430,   431,   431,   432,   433,   433,   435,   434,   436,   434,
     437,   434,   438,   434,   439,   434,   440,   441,   434,   443,
     442,   444,   442,   445,   442,   446,   442,   447,   442,   449,
     448,   451,   450,   453,   452,   454,   454,   454,   454,   454,
     454,   454,   454,   454,   454,   454,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   456,   456,   456,
     456,   456,   456,   456,   456,   456,   456,   456,   457,   458,
     459,   460,   460,   460,   461,   462,   463,   464,   464,   465,
     464,   466,   466,   466,   467,   468,   468,   469,   469,   469,
     470,   470,   471,   472,   472,   472,   472,   472,   472,   472,
     472,   472,   472,   472,   472,   473,   474,   474,   474,   475,
     476,   476,   477,   478,   478,   478,   480,   479,   481,   481,
     481,   482,   482,   482,   482,   482,   482,   482,   482,   482,
     482,   482,   482,   483,   483,   483,   483,   484,   484,   486,
     485,   487,   485,   488,   489,   489,   489,   489,   490,   490,
     490,   490,   491,   492,   492,   492,   492,   492,   493,   493,
     494,   494,   495,   495,   495,   495,   496,   496,   497,   497,
     498,   498,   499,   499,   500,   500,   501,   501,   501,   502,
     502,   502,   503,   503,   503,   504,   504,   504,   505,   505,
     506,   506,   507,   507,   508,   508,   509,   509,   509,   509,
     509,   509,   509,   510,   510,   510,   510,   510,   511,   511,
     511,   511,   511,   511,   511,   511,   511,   511,   511,   511,
     512,   512,   512,   512,   513,   513,   514,   514,   514,   514,
     514,   514,   514,   514
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     3,     0,     0,     4,     4,     4,
       4,     4,     2,     2,     1,    10,    10,    23,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     2,     2,
       1,     2,     1,     2,     2,     1,     0,     5,     0,     7,
       0,     7,     0,     5,     0,     5,     0,     5,     0,     3,
       0,     3,     0,     3,     1,     0,     3,     1,     1,     1,
       1,     1,     1,     0,     3,     1,     1,     1,     1,     0,
       3,     1,     0,     3,     1,     0,     3,     0,     3,     1,
       0,     5,     3,     3,     1,     1,     0,     5,     0,     5,
       0,     5,     0,    11,     0,    13,     0,    13,     1,     1,
       1,     1,     1,     1,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       8,     6,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     8,     8,     8,    10,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     0,
       2,     1,     1,     3,     1,     5,    10,    12,    12,    10,
      10,     8,    10,    10,     8,     8,     6,     8,     6,     6,
       4,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     1,     2,     1,     8,     9,     0,    12,     0,    12,
       0,    12,     0,    12,     0,    12,     0,     0,    12,     0,
      12,     0,    12,     0,    12,     0,    12,     0,    12,     0,
      17,     0,    17,     0,     9,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,    20,    13,
      16,     1,     1,     1,     1,     1,     1,     9,    16,     0,
      17,     1,     1,     1,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,    11,    13,    13,     1,
       6,     9,     7,     1,     1,     3,     0,    11,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     0,     2,     0,
       3,     0,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     0,     2,     2,     5,     5,
       5,     5,     5,     5,     1,     1,     1,     3,     3,     4,
       4,     3,     3,     1,     3,     1,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 689 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_shader(); }
#line 2794 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 707 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 2800 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 708 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.unum) = (yyvsp[0].num);      }
#line 2806 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 20:
#line 709 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.unum) = -(yyvsp[0].num);     }
#line 2812 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 21:
#line 710 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.unum) = (yyvsp[0].unum);      }
#line 2818 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 712 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 2828 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 23:
#line 718 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 2836 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 723 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 2849 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 733 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 2859 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 28:
#line 739 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 2869 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 29:
#line 745 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 2881 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 30:
#line 752 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 2892 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 759 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 2905 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 768 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { variant->branchstack = (yyvsp[0].unum); }
#line 2911 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 770 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 2917 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 772 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { info->early_preamble = 1; }
#line 2923 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 775 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { }
#line 2929 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 777 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { }
#line 2935 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 784 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { }
#line 2941 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 786 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.flags |= IR3_INSTR_SY; }
#line 2947 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 787 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.flags |= IR3_INSTR_SS; }
#line 2953 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 788 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.flags |= IR3_INSTR_JP; }
#line 2959 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 789 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.flags |= IR3_INSTR_SAT; }
#line 2965 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 42:
#line 790 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.repeat = (yyvsp[0].num); }
#line 2971 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 791 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.flags |= IR3_INSTR_UL; }
#line 2977 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 792 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { iflags.nop = (yyvsp[0].tok); }
#line 2983 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 805 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { fixup_cat5_s2en(); }
#line 2989 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 810 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_label((yyvsp[-1].str)); }
#line 2995 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 812 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3001 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 813 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3007 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 815 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3013 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 816 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3019 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 818 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat0.immed = (yyvsp[0].num); }
#line 3025 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 64:
#line 819 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3031 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 65:
#line 821 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_NOP); }
#line 3037 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 822 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3043 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 823 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3049 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 824 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3055 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 825 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3061 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 826 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3067 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 76:
#line 827 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3073 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 828 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3079 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 829 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_JUMP); }
#line 3085 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 830 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CALL); }
#line 3091 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 831 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RET); }
#line 3097 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 832 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_KILL); }
#line 3103 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 87:
#line 833 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_END); }
#line 3109 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 834 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_EMIT); }
#line 3115 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 835 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CUT); }
#line 3121 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 836 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CHMASK); }
#line 3127 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 837 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CHSH); }
#line 3133 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 838 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_FLOW_REV); }
#line 3139 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 839 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_BKT); }
#line 3145 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 95:
#line 840 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STKS); }
#line 3151 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 841 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STKR); }
#line 3157 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 842 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_XSET); }
#line 3163 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 98:
#line 843 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_XCLR); }
#line 3169 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 844 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETONE); }
#line 3175 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 101:
#line 845 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DBG); }
#line 3181 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 102:
#line 846 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHPS); }
#line 3187 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 847 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHPE); }
#line 3193 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 848 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_PREDT); }
#line 3199 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 849 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_PREDF); }
#line 3205 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 109:
#line 850 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_PREDE); }
#line 3211 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 851 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETLAST); }
#line 3217 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 853 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3225 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 856 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3233 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 863 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3243 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 867 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3259 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 879 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3270 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 886 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3281 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 893 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3287 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 895 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3293 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 897 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3299 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 909 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ABSNEG_F); }
#line 3305 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 910 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ABSNEG_S); }
#line 3311 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 911 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CLZ_B); }
#line 3317 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 912 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CLZ_S); }
#line 3323 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 913 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SIGN_F); }
#line 3329 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 914 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_FLOOR_F); }
#line 3335 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 142:
#line 915 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CEIL_F); }
#line 3341 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 143:
#line 916 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RNDNE_F); }
#line 3347 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 144:
#line 917 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RNDAZ_F); }
#line 3353 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 918 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_TRUNC_F); }
#line 3359 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 919 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_NOT_B); }
#line 3365 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 147:
#line 920 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_BFREV_B); }
#line 3371 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 921 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SETRM); }
#line 3377 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 922 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CBITS_B); }
#line 3383 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 924 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CMPS_F); }
#line 3389 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 151:
#line 925 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CMPS_U); }
#line 3395 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 926 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CMPS_S); }
#line 3401 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 927 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CMPV_F); }
#line 3407 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 928 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CMPV_U); }
#line 3413 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 929 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CMPV_S); }
#line 3419 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 156:
#line 931 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ADD_F); }
#line 3425 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 157:
#line 932 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MIN_F); }
#line 3431 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 933 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAX_F); }
#line 3437 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 159:
#line 934 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MUL_F); }
#line 3443 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 160:
#line 935 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ADD_U); }
#line 3449 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 936 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ADD_S); }
#line 3455 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 162:
#line 937 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SUB_U); }
#line 3461 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 938 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SUB_S); }
#line 3467 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 939 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MIN_U); }
#line 3473 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 940 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MIN_S); }
#line 3479 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 941 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAX_U); }
#line 3485 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 942 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAX_S); }
#line 3491 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 943 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_AND_B); }
#line 3497 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 944 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_OR_B); }
#line 3503 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 945 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_XOR_B); }
#line 3509 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 946 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MUL_U24); }
#line 3515 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 947 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MUL_S24); }
#line 3521 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 948 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MULL_U); }
#line 3527 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 949 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHL_B); }
#line 3533 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 175:
#line 950 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHR_B); }
#line 3539 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 176:
#line 951 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ASHR_B); }
#line 3545 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 952 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_BARY_F); }
#line 3551 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 953 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_FLAT_B); }
#line 3557 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 954 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MGEN_B); }
#line 3563 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 955 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETBIT_B); }
#line 3569 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 956 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHB); }
#line 3575 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 957 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MSAD); }
#line 3581 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 959 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat2.condition = IR3_COND_LT; }
#line 3587 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 960 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat2.condition = IR3_COND_LE; }
#line 3593 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 961 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat2.condition = IR3_COND_GT; }
#line 3599 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 962 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat2.condition = IR3_COND_GE; }
#line 3605 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 963 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat2.condition = IR3_COND_EQ; }
#line 3611 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 964 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat2.condition = IR3_COND_NE; }
#line 3617 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 970 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 3623 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 971 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 3629 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 973 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 3635 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 974 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 3641 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 976 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAD_U16); }
#line 3647 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 977 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MADSH_U16); }
#line 3653 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 978 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAD_S16); }
#line 3659 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 979 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MADSH_M16); }
#line 3665 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 980 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAD_U24); }
#line 3671 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 981 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAD_S24); }
#line 3677 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 982 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAD_F16); }
#line 3683 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 983 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_MAD_F32); }
#line 3689 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 984 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SEL_B16); }
#line 3695 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 985 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SEL_B32); }
#line 3701 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 986 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SEL_S16); }
#line 3707 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 207:
#line 987 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SEL_S32); }
#line 3713 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 208:
#line 988 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SEL_F16); }
#line 3719 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 209:
#line 989 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SEL_F32); }
#line 3725 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 210:
#line 990 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAD_S16); }
#line 3731 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 211:
#line 991 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAD_S32); }
#line 3737 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 212:
#line 993 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHRM); }
#line 3743 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 213:
#line 994 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHLM); }
#line 3749 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 214:
#line 995 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHRG); }
#line 3755 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 996 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SHLG); }
#line 3761 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 216:
#line 997 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ANDG); }
#line 3767 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 217:
#line 999 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_WMM); }
#line 3773 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1000 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_WMM_ACCU); }
#line 3779 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1002 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DP2ACC); }
#line 3785 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1003 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DP4ACC); }
#line 3791 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1010 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RCP); }
#line 3797 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1011 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RSQ); }
#line 3803 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1012 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LOG2); }
#line 3809 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1013 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_EXP2); }
#line 3815 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1014 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SIN); }
#line 3821 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1015 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_COS); }
#line 3827 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1016 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SQRT); }
#line 3833 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1017 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_HRSQ); }
#line 3839 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1018 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_HLOG2); }
#line 3845 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1019 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_HEXP2); }
#line 3851 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1023 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 3857 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1024 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 3863 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1026 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ISAM); }
#line 3869 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1027 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ISAML); }
#line 3875 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1028 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ISAMM); }
#line 3881 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1029 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAM); }
#line 3887 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1030 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAMB); }
#line 3893 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1031 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAML); }
#line 3899 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1032 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAMGQ); }
#line 3905 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1033 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETLOD); }
#line 3911 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1034 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CONV); }
#line 3917 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1035 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_CONVM); }
#line 3923 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1036 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETSIZE); }
#line 3929 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1037 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETBUF); }
#line 3935 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1038 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETPOS); }
#line 3941 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1039 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETINFO); }
#line 3947 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1040 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DSX); }
#line 3953 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1041 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_DSY); }
#line 3959 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1042 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GATHER4R); }
#line 3965 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1043 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GATHER4G); }
#line 3971 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1044 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GATHER4B); }
#line 3977 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1045 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GATHER4A); }
#line 3983 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1046 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAMGP0); }
#line 3989 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1047 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAMGP1); }
#line 3995 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1048 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAMGP2); }
#line 4001 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1049 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_SAMGP3); }
#line 4007 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1050 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RGETPOS); }
#line 4013 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1051 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RGETINFO); }
#line 4019 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1052 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_BRCST_ACTIVE); }
#line 4025 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1053 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4031 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1054 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4037 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1055 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4043 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1056 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4049 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1058 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_3D; }
#line 4055 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1059 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_A; }
#line 4061 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1060 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_O; }
#line 4067 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1061 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_P; }
#line 4073 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1062 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_S; }
#line 4079 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1063 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_S2EN; }
#line 4085 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1064 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { }
#line 4091 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1065 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4097 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1066 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4103 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1067 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4109 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1071 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat5.samp = (yyvsp[0].tok); }
#line 4115 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1072 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat5.tex = (yyvsp[0].tok); }
#line 4121 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1073 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat5.type = (yyvsp[-1].type); }
#line 4127 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1074 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_A1EN; }
#line 4133 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1093 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.typed = 0; }
#line 4139 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1094 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.typed = 1; }
#line 4145 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1096 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.d = 1; }
#line 4151 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1097 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.d = 2; }
#line 4157 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1098 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.d = 3; }
#line 4163 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1099 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.d = 4; }
#line 4169 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1101 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.type = (yyvsp[0].type); }
#line 4175 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1102 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4181 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1105 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4187 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1108 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4193 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1111 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                    }
#line 4203 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1116 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                    }
#line 4213 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1122 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDG); }
#line 4219 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1123 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDG_A); }
#line 4225 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1124 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDP); }
#line 4231 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1125 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDL); }
#line 4237 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1126 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDLW); }
#line 4243 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1127 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDLV); }
#line 4249 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1127 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4257 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1131 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STG); dummy_dst(); }
#line 4263 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1132 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STG_A); dummy_dst(); }
#line 4269 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1133 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STP); dummy_dst(); }
#line 4275 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1134 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STL); dummy_dst(); }
#line 4281 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1135 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STLW); dummy_dst(); }
#line 4287 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1137 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDIB); }
#line 4293 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1138 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STIB); dummy_dst(); }
#line 4299 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1140 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4305 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1142 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_ADD); }
#line 4311 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1143 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_SUB); }
#line 4317 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1144 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_XCHG); }
#line 4323 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1145 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_INC); }
#line 4329 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1146 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_DEC); }
#line 4335 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1147 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4341 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1148 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_MIN); }
#line 4347 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1149 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_MAX); }
#line 4353 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1150 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_AND); }
#line 4359 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1151 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_OR); }
#line 4365 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1152 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_XOR); }
#line 4371 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1154 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_ADD); }
#line 4377 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1155 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_SUB); }
#line 4383 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1156 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4389 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1157 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_INC); }
#line 4395 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1158 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_DEC); }
#line 4401 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1159 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4407 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1160 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_MIN); }
#line 4413 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1161 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_MAX); }
#line 4419 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1162 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_AND); }
#line 4425 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1163 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_OR); }
#line 4431 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1164 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_S_XOR); }
#line 4437 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1166 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_ADD); }
#line 4443 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1167 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_SUB); }
#line 4449 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1168 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4455 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1169 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_INC); }
#line 4461 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1170 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_DEC); }
#line 4467 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1171 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4473 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1172 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_MIN); }
#line 4479 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1173 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_MAX); }
#line 4485 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1174 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_AND); }
#line 4491 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1175 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_OR); }
#line 4497 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1176 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_G_XOR); }
#line 4503 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1188 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RESINFO); }
#line 4509 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1190 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDGB); }
#line 4515 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1191 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STGB); }
#line 4521 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1195 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { dummy_dst(); }
#line 4527 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1198 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETSPID); }
#line 4533 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1199 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETWID); }
#line 4539 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1200 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_GETFIBERID); }
#line 4545 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1205 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4551 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1209 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4557 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1212 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4563 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1214 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RESINFO); }
#line 4569 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1216 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 4575 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1217 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 4581 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1218 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 4587 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1219 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 4593 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1220 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 4599 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1221 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 4605 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1222 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 4611 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1223 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 4617 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1224 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 4623 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1225 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 4629 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1226 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 4635 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1227 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STIB); dummy_dst(); }
#line 4641 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1229 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDIB); }
#line 4647 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1232 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { swap(instr->srcs[0], instr->srcs[2]); }
#line 4653 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1233 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { swap(instr->srcs[0], instr->srcs[1]); }
#line 4659 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1235 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_LDC); }
#line 4665 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1239 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat6.d = (yyvsp[-5].tok); }
#line 4671 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1240 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->opc = OPC_LDC_K; }
#line 4677 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1242 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 4687 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1248 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4693 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1249 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 4699 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1250 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 4705 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1252 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_STC); }
#line 4711 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1254 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_G2L); }
#line 4717 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1255 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_L2G); }
#line 4723 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1256 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_RESFMT); }
#line 4729 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1271 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat7.w = true; }
#line 4735 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1272 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat7.r = true; }
#line 4741 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1273 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat7.l = true; }
#line 4747 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1274 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat7.g = true; }
#line 4753 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1279 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_BAR); }
#line 4759 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1280 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_instr(OPC_FENCE); }
#line 4765 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1284 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 4771 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1285 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 4777 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1286 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 4783 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1287 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 4789 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1289 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 4795 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1290 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 4801 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1291 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 4807 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1292 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 4813 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1294 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 4819 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1296 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat1.round = ROUND_EVEN; }
#line 4825 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1297 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat1.round = ROUND_POS_INF; }
#line 4831 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1298 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { instr->cat1.round = ROUND_NEG_INF; }
#line 4837 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1299 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { rflags.flags |= IR3_REG_EI; }
#line 4843 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1300 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { rflags.wrmask = (yyvsp[0].num); }
#line 4849 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1306 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4855 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1307 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 4861 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1309 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 4867 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1310 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { rflags.flags |= IR3_REG_NEGATE; }
#line 4873 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1311 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { rflags.flags |= IR3_REG_ABS; }
#line 4879 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1312 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { rflags.flags |= IR3_REG_R; }
#line 4885 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1341 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = 0; }
#line 4891 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1342 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 4897 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1343 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = -(yyvsp[0].num); }
#line 4903 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1345 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4909 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1346 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4915 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1348 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 4921 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 501:
#line 1349 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4927 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 1351 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 4933 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 1352 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 4939 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 506:
#line 1361 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 4945 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 507:
#line 1362 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4951 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 508:
#line 1363 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 4957 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 509:
#line 1364 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 4963 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 1365 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 4969 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 1366 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 4975 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 1367 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 4981 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 513:
#line 1369 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4987 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 514:
#line 1370 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 4993 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 515:
#line 1371 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 4999 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 516:
#line 1372 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5005 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 517:
#line 1373 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5011 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 530:
#line 1389 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].num); }
#line 5017 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 531:
#line 1390 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = -(yyvsp[0].num); }
#line 5023 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 532:
#line 1391 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = (yyvsp[0].unum); }
#line 5029 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 533:
#line 1392 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.num) = -(yyvsp[0].unum); }
#line 5035 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 534:
#line 1394 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.flt) = (yyvsp[0].flt); }
#line 5041 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 535:
#line 1395 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.flt) = -(yyvsp[0].flt); }
#line 5047 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 536:
#line 1397 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_F16; }
#line 5053 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 537:
#line 1398 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_F32; }
#line 5059 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 538:
#line 1399 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_U16; }
#line 5065 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 539:
#line 1400 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_U32; }
#line 5071 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 540:
#line 1401 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_S16; }
#line 5077 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 541:
#line 1402 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_S32; }
#line 5083 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 542:
#line 1403 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_U8;  }
#line 5089 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;

  case 543:
#line 1404 "../src/freedreno/ir3/ir3_parser.y" /* yacc.c:1646  */
    { (yyval.type) = TYPE_S8;  }
#line 5095 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
    break;


#line 5099 "src/freedreno/ir3/ir3_parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
